diff a/src/hotspot/share/gc/shared/gcConfiguration.cpp b/src/hotspot/share/gc/shared/gcConfiguration.cpp
--- a/src/hotspot/share/gc/shared/gcConfiguration.cpp
+++ b/src/hotspot/share/gc/shared/gcConfiguration.cpp
@@ -49,10 +49,15 @@
       return NA;
     }
   }
 
   if (UseShenandoahGC) {
+#if INCLUDE_SHENANDOAHGC
+    if (ShenandoahCardBarrier) {
+      return ShenandoahYoung;
+    }
+#endif
     return NA;
   }
 
   return DefNew;
 }
@@ -73,10 +78,15 @@
       return Z;
     }
   }
 
   if (UseShenandoahGC) {
+#if INCLUDE_SHENANDOAHGC
+    if (ShenandoahCardBarrier) {
+      return ShenandoahOld;
+    }
+#endif
     return Shenandoah;
   }
 
   return SerialOld;
 }
